{ Program: Update.exe
Task     : Update a local file if the remote is newer.
Author   : Tobias Gruetzmacher <tobias@portfolio16.de>
Copyright: GPL - see COPYING or http://www.gnu.org/ }
program Update;

uses
  Windows,
  SysUtils;

var
  IniFile:TextFile;
  LDir,RDir,UpFile,CopyAll,Exec,Params:string;
  PrgName:array[0..1024] of Char;
  LAge,RAge:integer;
  sr: TSearchRec;

// FullDir will add a Backslash at the end if none is present
function FullDir(Dir:string):string;
begin
  if Copy(Dir,Length(Dir),1)='\' then
    FullDir:=Dir
  else
    Fulldir:=Dir+'\';
end;

begin
  GetModuleFileName(GetModuleHandle(nil),PrgName,1024);

  // Read the config file
  AssignFile(IniFile,ChangeFileExt(string(PrgName),'.ini'));
  Reset(IniFile);
  ReadLn(IniFile,UpFile);  // 1. Line: Program name
  ReadLn(IniFile,RDir);    // 2. Line: Remote directory
  ReadLn(IniFile,LDir);    // 3. Line: Local directory (should be '.')
  ReadLn(IniFile,CopyAll); // 4. Line: Copy all files in the directory?
  ReadLn(IniFile,Exec);    // 5. Line: Should the program be executed?
  ReadLn(IniFile,Params);  // 6. Line: Which parameters should be passed to it
  CloseFile(IniFile);

  // Be sure to be in the right local directory
  if Length(LDir)<2 then
    LDir:=ExtractFileDir(string(PrgName));

  // Get file ages
  LAge:=FileAge(FullDir(LDir)+UpFile);
  RAge:=FileAge(FullDir(RDir)+UpFile);

  // Copy if remote is newer
  if (RAge<>-1) and (LAge<RAge) then
    // Copy all files in directory?
    if UpperCase(CopyAll)='YES' then
      if FindFirst(FullDir(RDir)+'*.*', faAnyFile, sr) = 0 then
        begin
        while FindNext(sr) = 0 do
          CopyFile(PChar(FullDir(RDir)+sr.Name),PChar(FullDir(LDir)+sr.Name),false);
        FindClose(sr);
        end
    else
      CopyFile(PChar(FullDir(RDir)+UpFile),PChar(FullDir(LDir)+UpFile),false);

  // Run if desired
  if UpperCase(Exec)='YES' then
    WinExec(PChar(FullDir(LDir)+UpFile+' '+Params), SW_SHOWNORMAL);
end.
